/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package it.eng.spagosoa.smx.components.tcp;

import java.util.List;

import javax.jbi.servicedesc.ServiceEndpoint;

import org.apache.servicemix.common.DefaultComponent;
import org.apache.servicemix.common.Endpoint;

/**
 * Binding component that implement TCP Server and Client endpoint, used
 * with Rhapsody integration. 
 * that use MINA framework {@link http://mina.apache.org}
 * 
 * @org.apache.xbean.XBean element="component"
 */
public class TCPComponent extends DefaultComponent
{

    private TCPEndpointType[] endpoints;
    
    public TCPEndpointType[] getEndpoints() {
        return endpoints;
    }
    
    public void setEndpoints(TCPEndpointType[] endpoints) {
        this.endpoints = endpoints;
    }

    protected List getConfiguredEndpoints() {
        return asList(getEndpoints());
    }

    protected Class[] getEndpointClasses() {
        return new Class[] { TCPConsumerEndpoint.class, TCPProviderEndpoint.class };
    }

    protected Endpoint getResolvedEPR(ServiceEndpoint ep) throws Exception {
        TCPProviderEndpoint endpoint = new TCPProviderEndpoint(this, ep);
        // TODO: initialize endpoint here
        endpoint.activate();
        return endpoint;
    }

}
