/**

    Copyright 2007 Engineering Ingegneria Informatica S.p.A.

    This file is part of Spagic.

    Spagic is free software; you can redistribute it and/or modify
    it under the terms of the GNU Lesser General Public License as published by
    the Free Software Foundation; either version 3 of the License, or
    any later version.

    Spagic is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
**/
package it.eng.spagosoa.smx.components.tcp.util;

import javax.jbi.messaging.NormalizedMessage;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathFactory;

import org.apache.servicemix.jbi.jaxp.SourceTransformer;
import org.w3c.dom.Node;

public class NMUtils {
    
    public static Object retrieveMessageInEnvelope(NormalizedMessage in, String xpathString)
   		throws Exception {
    	
    	SourceTransformer domTransformer = new SourceTransformer();
    	
    	Node node = domTransformer.toDOMDocument(in.getContent());
    	XPath xpath = XPathFactory.newInstance().newXPath(); 
    	String nmEnvelope = xpath.evaluate(xpathString, node);
    	if (nmEnvelope == null) {
    		throw new Exception("Normalize message envelope ("+xpathString+") not found in Input NM");
    	}
    	return nmEnvelope.getBytes();
    }
}
